function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _createForOfIteratorHelper(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;

      var F = function () {};

      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var normalCompletion = true,
      didErr = false,
      err;
  return {
    s: function () {
      it = o[Symbol.iterator]();
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}

var nArray = /*#__PURE__*/function () {
  function nArray(array, shape) {
    var is_sparse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    _classCallCheck(this, nArray);

    _defineProperty(this, "data", []);

    _defineProperty(this, "index", []);

    _defineProperty(this, "shape", []);

    _defineProperty(this, "is_sparse", false);

    this.is_sparse = is_sparse; // if sparse

    if (is_sparse) {
      var extracted_data = extract(array);

      for (var d = 0; d < extracted_data.length; d++) {
        if (extracted_data[d] != 0) {
          this.data.push(extracted_data[d]);
          this.index.push(d);
        }
      }
    } // if dense
    else {
        this.data = extract(array);
      }

    this.shape = shape ? Array.from(shape) : find_shape(array);
  }

  _createClass(nArray, [{
    key: "get_data",
    value: function get_data(i) {
      return this.data[i];
    }
  }, {
    key: "get_index",
    value: function get_index(i) {
      if (this.is_sparse) return this.index[i];else return i;
    }
  }, {
    key: "print",
    value: function print() {
      // reconstructing the data
      var data = [];

      if (!this.is_sparse) {
        data = this.data;
      } else {
        var tot = this.shape.reduce(function (a, b) {
          return a * b;
        });
        var cur = 0;

        for (var d = 0; d < this.index.length; d++) {
          if (cur == this.index[d]) {
            data[cur] = this.data[d];
            cur++;
          } else {
            var missing = this.index[d] - cur;

            for (var m = 0; m < missing; m++) {
              data.push(0);
            }

            data.push(this.data[d]);
            cur = this.index[d];
            cur++;
          }
        }

        var last_missing = tot - data.length;

        for (var _i = 0; _i < last_missing; _i++) {
          data.push(0);
        }
      }

      var ns = "";
      var t_el = [];

      for (var _i2 = 0; _i2 < this.shape.length; _i2++) {
        var t = 1;

        for (var j = _i2; j < this.shape.length; j++) {
          t *= this.shape[j];
        }

        t_el.push(t);
      }

      for (var _i3 = 0; _i3 < this.shape.length; _i3++) {
        ns += "[";
      }

      var i = 0;
      var count = 0;

      for (var di = 0; di < data.length; di++) {
        var _d = data[di];

        var _iterator = _createForOfIteratorHelper(t_el),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var s = _step.value;

            if (i % s == 0) {
              count++;
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        if (i != 0) {
          if (count > 0) {
            ns = ns.substring(0, ns.length - 1);

            for (var _i4 = 0; _i4 < count; _i4++) {
              ns += "]";
            }

            ns += ",";

            for (var _i5 = 0; _i5 < count; _i5++) {
              ns += "[";
            }
          }
        }

        ns += _d;
        ns += ",";
        i++;
        count = 0;
      }

      ns = ns.substring(0, ns.length - 1);

      for (var _i6 = 0; _i6 < this.shape.length; _i6++) {
        ns += "]";
      }
      this.print_tensor(ns, this.shape.length);
    }
  }, {
    key: "print_tensor",
    value: function print_tensor(res, count) {
      var str = res;
      console.log("".concat(this.is_sparse ? 'Sparse ' : '', "Tensor"));
      var to_print = "";

      for (var c = 0; c < str.length; c++) {
        if (str[c] == ',' && str[c + 1] == '[') {
          var cn_count = 0;

          for (var cn = c + 1; cn < str.length; cn++) {
            if (str[cn] != '[') break;
            cn_count += 1;
          }

          for (var i = 0; i < cn_count; i++) {
            to_print += "\n";
          }

          for (var _i7 = 0; _i7 < count - cn_count; _i7++) {
            to_print += " ";
          }

          continue;
        } else if (str[c] == ',') {
          to_print += " ";
        } else {
          to_print += str[c];
        }
      }

      console.log(to_print + "\n");
    }
  }]);

  return nArray;
}(); // --------------------- helper functions ---------------------

function find_shape(array) {
  if (Array.isArray(array)) {
    var _shape = [];

    _shape.push(array.length);

    find_shape(array[0]).forEach(function (v) {
      _shape.push(v);
    });
    return _shape;
  } else {
    return [];
  }
}
function extract(array) {
  if (typeof array != "number") {
    var _ret = function () {
      var res = [];

      for (var a = 0; a < array.length; a++) {
        var el = array[a];
        extract(el).forEach(function (e) {
          res.push(e);
        });
      }

      return {
        v: res
      };
    }();

    if (_typeof(_ret) === "object") return _ret.v;
  } else {
    return [array];
  }
}

var nArray$1 = /*#__PURE__*/function () {
  function nArray(array, shape) {
    var is_sparse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    _classCallCheck(this, nArray);

    _defineProperty(this, "data", []);

    _defineProperty(this, "index", []);

    _defineProperty(this, "shape", []);

    _defineProperty(this, "is_sparse", false);

    this.is_sparse = is_sparse; // if sparse

    if (is_sparse) {
      var extracted_data = extract$1(array);

      for (var d = 0; d < extracted_data.length; d++) {
        if (extracted_data[d] != 0) {
          this.data.push(extracted_data[d]);
          this.index.push(d);
        }
      }
    } // if dense
    else {
        this.data = extract$1(array);
      }

    this.shape = shape ? Array.from(shape) : find_shape$1(array);
  }

  _createClass(nArray, [{
    key: "get_data",
    value: function get_data(i) {
      return this.data[i];
    }
  }, {
    key: "get_index",
    value: function get_index(i) {
      if (this.is_sparse) return this.index[i];else return i;
    }
  }, {
    key: "print",
    value: function print() {
      // reconstructing the data
      var data = [];

      if (!this.is_sparse) {
        data = this.data;
      } else {
        var tot = this.shape.reduce(function (a, b) {
          return a * b;
        });
        var cur = 0;

        for (var d = 0; d < this.index.length; d++) {
          if (cur == this.index[d]) {
            data[cur] = this.data[d];
            cur++;
          } else {
            var missing = this.index[d] - cur;

            for (var m = 0; m < missing; m++) {
              data.push(0);
            }

            data.push(this.data[d]);
            cur = this.index[d];
            cur++;
          }
        }

        var last_missing = tot - data.length;

        for (var _i = 0; _i < last_missing; _i++) {
          data.push(0);
        }
      }

      var ns = "";
      var t_el = [];

      for (var _i2 = 0; _i2 < this.shape.length; _i2++) {
        var t = 1;

        for (var j = _i2; j < this.shape.length; j++) {
          t *= this.shape[j];
        }

        t_el.push(t);
      }

      for (var _i3 = 0; _i3 < this.shape.length; _i3++) {
        ns += "[";
      }

      var i = 0;
      var count = 0;

      for (var di = 0; di < data.length; di++) {
        var _d = data[di];

        var _iterator = _createForOfIteratorHelper(t_el),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var s = _step.value;

            if (i % s == 0) {
              count++;
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        if (i != 0) {
          if (count > 0) {
            ns = ns.substring(0, ns.length - 1);

            for (var _i4 = 0; _i4 < count; _i4++) {
              ns += "]";
            }

            ns += ",";

            for (var _i5 = 0; _i5 < count; _i5++) {
              ns += "[";
            }
          }
        }

        ns += _d;
        ns += ",";
        i++;
        count = 0;
      }

      ns = ns.substring(0, ns.length - 1);

      for (var _i6 = 0; _i6 < this.shape.length; _i6++) {
        ns += "]";
      }
      this.print_tensor(ns, this.shape.length);
    }
  }, {
    key: "print_tensor",
    value: function print_tensor(res, count) {
      var str = res;
      console.log("".concat(this.is_sparse ? 'Sparse ' : '', "Tensor"));
      var to_print = "";

      for (var c = 0; c < str.length; c++) {
        if (str[c] == ',' && str[c + 1] == '[') {
          var cn_count = 0;

          for (var cn = c + 1; cn < str.length; cn++) {
            if (str[cn] != '[') break;
            cn_count += 1;
          }

          for (var i = 0; i < cn_count; i++) {
            to_print += "\n";
          }

          for (var _i7 = 0; _i7 < count - cn_count; _i7++) {
            to_print += " ";
          }

          continue;
        } else if (str[c] == ',') {
          to_print += " ";
        } else {
          to_print += str[c];
        }
      }

      console.log(to_print + "\n");
    }
  }]);

  return nArray;
}(); // --------------------- helper functions ---------------------

function find_shape$1(array) {
  if (Array.isArray(array)) {
    var _shape = [];

    _shape.push(array.length);

    find_shape$1(array[0]).forEach(function (v) {
      _shape.push(v);
    });
    return _shape;
  } else {
    return [];
  }
}
function extract$1(array) {
  if (typeof array != "number") {
    var _ret = function () {
      var res = [];

      for (var a = 0; a < array.length; a++) {
        var el = array[a];
        extract$1(el).forEach(function (e) {
          res.push(e);
        });
      }

      return {
        v: res
      };
    }();

    if (_typeof(_ret) === "object") return _ret.v;
  } else {
    return [array];
  }
}

var util = /*#__PURE__*/function () {
  function util() {
    _classCallCheck(this, util);
  }

  _createClass(util, null, [{
    key: "cal_step",
    value: function cal_step(shape) {
      var pos = 0;
      var res = [];

      for (var s = 0; s < shape.length; s++) {
        if (s == shape.length - 1) {
          res[pos] = 1;
          pos++;
        } else {
          var tot = 1;

          for (var l = s + 1; l < shape.length; l++) {
            tot *= shape[l];
          }
          res[pos] = tot;
          pos++;
        }
      }

      return res;
    }
  }, {
    key: "cal_index",
    value: function cal_index(index, step) {
      var res = 0;

      for (var i = 0; i < index.length; i++) {
        res += index[i] * step[i];
      }
      return res;
    }
  }, {
    key: "copy_to",
    value: function copy_to(from, to) {
      for (var i = 0; i < from.length; i++) {
        to[i] = from[i];
      }
    }
  }, {
    key: "cal_step_change",
    value: function cal_step_change(step, dimension) {
      var res = [];

      for (var d = 0; d < step.length; d++) {
        res[d] = step[dimension[d]];
      }
      return res;
    }
  }, {
    key: "find_index",
    value: function find_index(shape, step, index) {
      var res = [];

      for (var s = 0; s < shape.length; s++) {
        res[s] = shape[s] * step[s];
        res[s] = Math.floor(index % res[s] / step[s]);
      }

      return res;
    }
  }]);

  return util;
}();
var Basic_types;

(function (Basic_types) {
  Basic_types[Basic_types["add"] = 0] = "add";
  Basic_types[Basic_types["sub"] = 1] = "sub";
  Basic_types[Basic_types["mul"] = 2] = "mul";
  Basic_types[Basic_types["div"] = 3] = "div";
})(Basic_types || (Basic_types = {}));
var ops = /*#__PURE__*/function () {
  function ops() {
    _classCallCheck(this, ops);
  }

  _createClass(ops, null, [{
    key: "basic_op",
    value: function basic_op(a, b, op_type) {
      switch (op_type) {
        default:
        case Basic_types.add:
          return a + b;

        case Basic_types.sub:
          return a - b;

        case Basic_types.mul:
          return a * b;

        case Basic_types.div:
          return a / b;
      }
    }
  }, {
    key: "match_dim",
    value: function match_dim(s1, s2) {
      var larger = Array.from(s1);
      var smaller = Array.from(s2);

      if (s1.length < s2.length) {
        larger = s2;
        smaller = s1;
      }

      for (var s = 0; s < smaller.length; s++) {
        if (larger[s] != smaller[s]) {
          if (larger[s] != 1 && smaller[s] != 1) {
            throw new Error("can't broadcast ".concat(larger, " and ").concat(smaller));
          }
        }
      }

      var fill_count = larger.length - smaller.length;

      for (var i = 0; i < fill_count; i++) {
        smaller.unshift(1);
      }

      return [larger, smaller];
    }
  }, {
    key: "broadcast_dim",
    value: function broadcast_dim(a1, a2) {
      var s1 = Array.from(a1);
      var s2 = Array.from(a2);

      for (var s = 0; s < s2.length - 2; s++) {
        if (s1[s] != s2[s]) {
          if (s1[s] != 1 && s2[s] != 1) {
            throw new Error("can't broadcast ".concat(s1, " and ").concat(s2));
          }
        }
      }

      var len = s1.length - s2.length;

      for (var _s = 0; _s < len; _s++) {
        s2.unshift(1);
      }

      var res = [];

      for (var _s2 = 0; _s2 < s1.length; _s2++) {
        res.push(Math.max(s1[_s2], s2[_s2]));
      }

      return [s1, s2, res];
    }
  }, {
    key: "basic",
    value: function basic(a, b, result) {
      var op_type = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : Basic_types.add;

      if (op_type == this.basic_types.sub) {
        var n = new nArray$1(b.data, b.shape, b.is_sparse);

        for (var i = 0; i < n.data.length; i++) {
          n.data[i] *= -1;
        }

        b = n;
        op_type = this.basic_types.add;
      }

      if (a.shape.reduce(function (n1, n2) {
        return n1 * n2;
      }) > b.shape.reduce(function (n1, n2) {
        return n1 * n2;
      })) {
        return this.basic_main(a, b, result, op_type);
      } else {
        return this.basic_main(b, a, result, op_type);
      }
    }
  }, {
    key: "basic_main",
    value: function basic_main(a, b, result, op_type) {
      var _this = this;

      var _this$broadcast_dim = this.broadcast_dim(a.shape, b.shape),
          _this$broadcast_dim2 = _slicedToArray(_this$broadcast_dim, 3),
          a_shape = _this$broadcast_dim2[0],
          b_shape = _this$broadcast_dim2[1],
          res_shape = _this$broadcast_dim2[2];

      var _map = [a_shape, b_shape, res_shape].map(function (v) {
        return util.cal_step(v);
      }),
          _map2 = _slicedToArray(_map, 3),
          a_step = _map2[0],
          b_step = _map2[1],
          res_step = _map2[2];

      var size = res_shape.reduce(function (a, b) {
        return a * b;
      });

      if (a.is_sparse == true || b.is_sparse == true) {
        var apos = 0,
            bpos = 0,
            rpos = 0;
        var li = -1;

        var _loop = function _loop() {
          bpos %= b.data.length;
          var aindex = util.find_index(res_shape, res_step, a.get_index(apos));
          var bindex = util.find_index(res_shape, res_step, b.get_index(bpos));
          var rindex = aindex.map(function (a, b) {
            return Math.max(a, bindex[b]);
          });
          aindex = aindex.map(function (v, i) {
            return v % b_shape[i];
          });
          bindex = bindex.map(function (v, i) {
            return v % a_shape[i];
          });
          var ai = util.cal_index(aindex, b_step);
          var bi = util.cal_index(bindex, a_step);
          var ri = util.cal_index(rindex, res_step);

          if (ai < bi) {
            apos++;
          } else if (ai > bi) {
            bpos++;
          } else {
            if (li + 1 < ri) {
              for (var _i = li + 1; _i < ri; _i++) {
                var _i_in_res = util.find_index(res_shape, res_step, _i);

                var _i_in_b = util.cal_index(_i_in_res.map(function (v, i) {
                  return v % b_shape[i];
                }), b_step);

                result.data[rpos] = b.data[_i_in_b];
                result.index[rpos] = _i;
                rpos++;
              }
            }

            result.data[rpos] = _this.basic_op(a.data[apos], b.data[bpos], op_type);
            result.index[rpos] = ri;
            li = ri;
            rpos++;
            apos++;
            bpos++;
          }
        };

        while (apos < a.data.length) {
          _loop();
        }

        if (li < size) {
          for (var i = li + 1; i < size; i++) {
            var i_in_res = util.find_index(res_shape, res_step, i);
            var i_in_b = util.cal_index(i_in_res.map(function (v, i) {
              return v % b_shape[i];
            }), b_step);
            result.data[rpos] = b.data[i_in_b];
            result.index[rpos] = i;
            rpos++;
          }
        }

        return result;
      } else {
        for (var d = 0; d < size; d++) {
          var res_index = util.find_index(res_shape, a_step, d);
          var aindex = res_index.map(function (r, i) {
            return r % a_shape[i];
          });
          var bindex = res_index.map(function (r, i) {
            return r % b_shape[i];
          });
          var ai = util.cal_index(aindex, a_step);
          var bi = util.cal_index(bindex, b_step);
          result.data[d] = this.basic_op(a.data[ai], b.data[bi], op_type);
        }
        return result;
      }
    }
  }, {
    key: "unbroadcast",
    value: function unbroadcast(a, original_shape) {
      var _this$match_dim = this.match_dim(a.shape, original_shape),
          _this$match_dim2 = _slicedToArray(_this$match_dim, 2),
          a_shape = _this$match_dim2[0],
          o_shape = _this$match_dim2[1];

      var _ref = [util.cal_step(a.shape), util.cal_step(o_shape)],
          a_step = _ref[0],
          o_step = _ref[1];
      var res = new Array(original_shape.reduce(function (a, b) {
        return a * b;
      })).fill(0);
      a.data.forEach(function (d, i) {
        var a_index = util.find_index(a.shape, a_step, i);
        var o_index = [];
        a_index.forEach(function (ai, i) {
          o_index[i] = ai % o_shape[i];
        });
        var o = util.cal_index(o_index, o_step);
        res[o] += d;
      });
      return new nArray$1(res, original_shape, a.is_sparse);
    }
  }, {
    key: "reduce_sum",
    value: function reduce_sum(a, axis) {
      var a_splited = this.split_till(a.data, a.shape, axis);
      var res = new Array(a_splited[0].length).fill(0);

      for (var i = 0; i < a_splited.length; i++) {
        a_splited[i].forEach(function (v, i) {
          res[i] += v;
        });
      }

      return new nArray$1(res, a.shape.slice(axis), a.is_sparse);
    }
  }, {
    key: "split_till",
    value: function split_till(val, shape, axis) {
      var a_shape = shape.slice(axis);
      var tot_el = a_shape.length != 0 ? a_shape.reduce(function (a, b) {
        return a * b;
      }) : 1;
      var res = [];

      for (var i = 0; i < val.length / tot_el; i++) {
        res.push(val.slice(i * tot_el, i * tot_el + tot_el));
      }

      return res;
    }
  }, {
    key: "transpose",
    value: function transpose(a, res, dimension) {
      var step = util.cal_step(a.shape);
      var tshape = util.cal_step_change(a.shape, dimension);
      var tstep = util.cal_step(tshape);
      res.shape = Array.from(tshape);

      for (var i = 0; i < a.data.length; i++) {
        var index = util.find_index(a.shape, step, a.is_sparse ? a.index[i] : i);
        var new_index = util.cal_index(util.cal_step_change(index, dimension), tstep);

        if (a.is_sparse == false) {
          res.data[new_index] = a.data[i];
        } else {
          var j = i;
          res.index[j] = new_index;
          res.data[j] = a.data[j];

          while (res.index[j - 1] > res.index[j] && j > 0) {
            // swaping index
            var t = void 0;
            t = res.index[j];
            res.index[j] = res.index[j - 1];
            res.index[j - 1] = t; // swaping data

            t = res.data[j];
            res.data[j] = res.data[j - 1];
            res.data[j - 1] = t;
            j--;
          }
        }
      }

      return res;
    }
  }, {
    key: "strassen",
    value: function strassen(a, b) {
      var m1, m2, m3, m4, m5, m6, m7;
      var a0 = a[0];
      var a1 = a[1];
      var a2 = a[2];
      var a3 = a[3];
      var b0 = b[0];
      var b1 = b[1];
      var b2 = b[2];
      var b3 = b[3];
      m1 = (a0 + a3) * (b0 + b3);
      m2 = (a2 + a3) * b0;
      m3 = a0 * (b1 - b3);
      m4 = a3 * (b2 - b0);
      m5 = (a0 + a1) * b3;
      m6 = (a2 - a0) * (b0 + b1);
      m7 = (a1 - a3) * (b2 + b3);
      var res = [];
      res[0] = m1 + m4 - m5 + m7;
      res[1] = m3 + m5;
      res[2] = m2 + m4;
      res[3] = m1 - m2 + m3 + m6;
      return res;
    }
  }, {
    key: "broadcast_matmul_dim",
    value: function broadcast_matmul_dim(a1, a2) {
      var s1 = Array.from(a1);
      var s2 = Array.from(a2);
      var is_swaped = false;

      if (a1.reduce(function (a, b) {
        return a * b;
      }) < a2.reduce(function (a, b) {
        return a * b;
      })) {
        is_swaped = true;
        var t = s1;
        s1 = s2;
        s2 = t;
      }

      for (var s = 0; s < s2.length - 2; s++) {
        if (s1[s] != s2[s]) {
          if (s1[s] != 1 && s2[s] != 1) {
            throw new Error("can't broadcast ".concat(s1, " and ").concat(s2));
          }
        }
      }

      if (a1[a1.length - 1] != a2[a2.length - 2]) {
        throw new Error("shape1: ".concat(s1, " , shape2: ").concat(s2, ", {m, k} x {k, n} = {m, n} => k value should match"));
      }
      var len = s1.length - s2.length;

      for (var _s3 = 0; _s3 < len; _s3++) {
        s2.unshift(1);
      }

      var res = [];

      for (var _s4 = 0; _s4 < s1.length - 2; _s4++) {
        res.push(Math.max(s1[_s4], s2[_s4]));
      }

      res.push(a1[a1.length - 2], a2[a2.length - 1]);
      return is_swaped ? [s2, s1, res] : [s1, s2, res];
    }
  }, {
    key: "broadcast_down",
    value: function broadcast_down(broadcasted_shape, broadcasted_step, real_shape, real_step, i) {
      var index = util.find_index(broadcasted_shape, broadcasted_step, i);
      index = index.map(function (v, i) {
        return v % real_shape[i];
      });
      return util.cal_index(index, real_step);
    }
  }, {
    key: "matmul",
    value: function matmul(a, b, res) {
      var _this2 = this;

      // half broadcasted shape & step
      var _this$broadcast_matmu = this.broadcast_matmul_dim(a.shape, b.shape),
          _this$broadcast_matmu2 = _slicedToArray(_this$broadcast_matmu, 3),
          a_shape = _this$broadcast_matmu2[0],
          b_shape = _this$broadcast_matmu2[1],
          res_shape = _this$broadcast_matmu2[2];

      var _map3 = [a_shape, b_shape, res_shape].map(function (v) {
        return util.cal_step(v);
      }),
          _map4 = _slicedToArray(_map3, 3),
          a_step = _map4[0],
          b_step = _map4[1],
          res_step = _map4[2]; // fully broadcasted shape & step


      var _ref2 = [Array.from(res_shape), Array.from(res_shape), Array.from(res_shape)],
          n_a_shape = _ref2[0],
          n_b_shape = _ref2[1],
          n_res_shape = _ref2[2];
      n_a_shape[n_a_shape.length - 1] = a_shape[n_a_shape.length - 1];
      n_a_shape[n_a_shape.length - 2] = a_shape[n_a_shape.length - 2];
      n_b_shape[n_a_shape.length - 1] = b_shape[n_a_shape.length - 1];
      n_b_shape[n_a_shape.length - 2] = b_shape[n_a_shape.length - 2];

      var _map5 = [n_a_shape, n_b_shape, n_res_shape].map(function (v) {
        return util.cal_step(v);
      }),
          _map6 = _slicedToArray(_map5, 3),
          n_a_step = _map6[0],
          n_b_step = _map6[1],
          n_res_step = _map6[2]; // size and step of a, b & res of fully broadcasted shape & step


      var size = n_res_shape.reduce(function (a, b) {
        return a * b;
      });
      var count = size / (n_res_shape[n_res_shape.length - 2] * n_res_shape[n_res_shape.length - 1]);
      var a_split_size = n_a_shape[n_a_shape.length - 2] * n_a_shape[n_a_shape.length - 1];
      var b_split_size = n_b_shape[n_b_shape.length - 2] * n_b_shape[n_b_shape.length - 1];
      var res_split_size = n_res_shape[n_res_shape.length - 2] * n_res_shape[n_res_shape.length - 1]; // converting fully broadcasted shape & step to half

      var get_down_a = function get_down_a(i) {
        return _this2.broadcast_down(n_a_shape, n_a_step, a_shape, a_step, i);
      };

      var get_down_b = function get_down_b(i) {
        return _this2.broadcast_down(n_b_shape, n_b_step, b_shape, b_step, i);
      };

      if (a.is_sparse == true || b.is_sparse == true) {
        res.data.length = 0;
        res.index.length = 0;
        var apos = 0,
            bpos = 0;
        var astep_id = 0,
            bstep_id = 0;

        for (apos = 0; apos < a.data.length; apos++) {
          var n_a_index = util.find_index(n_a_shape, n_a_step, a.get_index(apos));
          astep_id = Math.floor(get_down_b(a.get_index(apos)) / b_split_size);

          var _loop2 = function _loop2() {
            bstep_id = Math.floor(get_down_a(b.get_index(bpos)) / a_split_size);
            var n_b_index = util.find_index(n_b_shape, n_b_step, b.get_index(bpos));
            var n_res_index = n_a_index.map(function (na, i) {
              return Math.max(na, n_b_index[i]);
            });
            n_res_index[n_res_index.length - 2] = n_a_index[n_b_index.length - 2];
            n_res_index[n_res_index.length - 1] = n_b_index[n_b_index.length - 1];

            if (n_a_index[n_b_index.length - 1] == n_b_index[n_b_index.length - 2]) {
              if (astep_id == bstep_id) {
                var rpos = util.cal_index(n_res_index, n_res_step);

                if (res.index.length == 0) {
                  res.data.push(a.data[apos] * b.data[bpos]);
                  res.index.push(rpos);
                } else {
                  var is_exist = false;

                  for (var r = res.index.length - 1; r >= 0; r--) {
                    if (res.index[r] == rpos) {
                      res.data[r] += a.data[apos] * b.data[bpos];
                      is_exist = true;
                    }
                  }

                  if (!is_exist) {
                    res.data.push(a.data[apos] * b.data[bpos]);
                    res.index.push(rpos);
                  }
                }
              }
            }
          };

          for (bpos = 0; bpos < b.data.length; bpos++) {
            _loop2();
          }
        }

        return res;
      } else {
        // broadcast is supported                                 
        // ref to last two indices
        var fi = res_shape.length - 2;
        var si = res_shape.length - 1; // matmul

        for (var s = 0; s < count; s++) {
          for (var i = 0; i < n_a_shape[fi]; i += 2) {
            for (var j = 0; j < n_a_shape[si]; j += 2) {
              for (var k = 0; k < n_b_shape[si]; k += 2) {
                var stra_res = this.strassen([i < n_a_shape[fi] && j < n_a_shape[si] ? a.data[get_down_a(s * a_split_size + i * n_a_step[fi] + j * n_a_step[si])] : 0, i < n_a_shape[fi] && j + 1 < n_a_shape[si] ? a.data[get_down_a(s * a_split_size + i * n_a_step[fi] + (j + 1) * n_a_step[si])] : 0, i + 1 < n_a_shape[fi] && j < n_a_shape[si] ? a.data[get_down_a(s * a_split_size + (i + 1) * n_a_step[fi] + j * n_a_step[si])] : 0, i + 1 < n_a_shape[fi] && j + 1 < n_a_shape[si] ? a.data[get_down_a(s * a_split_size + (i + 1) * n_a_step[fi] + (j + 1) * n_a_step[si])] : 0], [j < n_b_shape[fi] && k < n_b_shape[si] ? b.data[get_down_b(s * b_split_size + j * n_b_step[fi] + k * n_b_step[si])] : 0, j < n_b_shape[fi] && k + 1 < n_b_shape[si] ? b.data[get_down_b(s * b_split_size + j * n_b_step[fi] + (k + 1) * n_b_step[si])] : 0, j + 1 < n_b_shape[fi] && k < n_b_shape[si] ? b.data[get_down_b(s * b_split_size + (j + 1) * n_b_step[fi] + k * n_b_step[si])] : 0, j + 1 < n_b_shape[fi] && k + 1 < n_b_shape[si] ? b.data[get_down_b(s * b_split_size + (j + 1) * n_b_step[fi] + (k + 1) * n_b_step[si])] : 0]);
                var pos = void 0;

                if (i < n_res_shape[fi] && k < n_res_shape[si]) {
                  pos = s * res_split_size + i * n_res_step[fi] + k * n_res_step[si];
                  res.data[pos] ? res.data[pos] += stra_res[0] : res.data[pos] = stra_res[0];
                }

                if (i < n_res_shape[fi] && k + 1 < n_res_shape[si]) {
                  pos = s * res_split_size + i * n_res_step[fi] + (k + 1) * n_res_step[si];
                  res.data[pos] ? res.data[pos] += stra_res[0] : res.data[pos] = stra_res[1];
                }

                if (i + 1 < n_res_shape[fi] && k < n_res_shape[si]) {
                  pos = s * res_split_size + (i + 1) * n_res_step[fi] + k * n_res_step[si];
                  res.data[pos] ? res.data[pos] += stra_res[0] : res.data[pos] = stra_res[2];
                }

                if (i + 1 < n_res_shape[fi] && k + 1 < n_res_shape[si]) {
                  pos = s * res_split_size + (i + 1) * n_res_step[fi] + (k + 1) * n_res_step[si];
                  res.data[pos] ? res.data[pos] += stra_res[0] : res.data[pos] = stra_res[3];
                }
              }
            }
          }
        }

        res.data.length = size;
        res.shape = n_res_shape;
        return res;
      }
    }
  }, {
    key: "applyfn",
    value: function applyfn(a, res, fn) {
      for (var d = 0; d < a.data.length; d++) {
        res.data[d] = fn(a.data[d]);
        if (res.is_sparse) if (a.index[d]) res.index[d] = a.index[d];
      }

      return res;
    }
  }]);

  return ops;
}();

_defineProperty(ops, "basic_types", Basic_types);
// let r = new nArray(new Array(2).fill(0), [2, 2], true)
// ops.matmul(    
//     new nArray([1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 12], [3, 1, 1, 2, 2, 1], true),
//     new nArray([1, 2], [1, 2], true),
//     r,    
// )
// r.print();
// console.timeEnd("start")
// console.log("start")
// console.time("start")
// let a = new nArray([1, 2, 0, 0, 5, 6, 0, 0], [2, 2, 2], false);
// let b = new nArray([1, 2, 3, 4], [2, 2], false);
// let r = new nArray([], [2, 2, 2], false)
// ops.basic_main(    
//     a,
//     b,
//     r,  
//     ops.basic_types.add 
// )
// r.print();
// console.timeEnd("start")
// console.log(ops.broadcast_dim([3, 1, 2, 2, 2, 1], [3, 2, 1, 2, 1, 2]));
// Array
// [
//   2, 4,  6,  8,
//   6, 8, 10, 12
// ]
// [ 2, 2, 2, 2, 2 ]
// from
// [[[1 2]]
//  [[3 4]]]
// to
// [[[1, 2],
//   [1, 2]],
//  [[3, 4],
//   [3, 4]]]

function randGauss() {
  if (randGauss["return"]) {
    randGauss["return"] = false;
    return randGauss.val;
  }

  var u = 2 * Math.random() - 1;
  var v = 2 * Math.random() - 1;
  var r = u * u + v * v;
  if (r === 0 || r > 1) return randGauss();
  var c = Math.sqrt(-2 * Math.log(r) / r);
  randGauss.val = v * c;
  randGauss["return"] = true;
  return u * c;
}
randGauss["return"] = false;
randGauss.val = 0;
function randn(m, std) {
  return m + randGauss() * std;
}

var Tensor = /*#__PURE__*/function () {
  _createClass(Tensor, [{
    key: "feed",
    value: function feed() {}
  }, {
    key: "back",
    value: function back() {}
  }]);

  function Tensor(array, shape) {
    var is_sparse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

    _classCallCheck(this, Tensor);

    _defineProperty(this, "value", void 0);

    _defineProperty(this, "grad", void 0);

    _defineProperty(this, "parents", void 0);

    this.value = new nArray(array, shape, is_sparse);
    this.grad = new nArray(new Array(this.value.data.length).fill(0), shape, is_sparse);
    this.parents = [null, null];
  }

  _createClass(Tensor, [{
    key: "print",
    value: function print() {
      this.value.print();
    }
  }]);

  return Tensor;
}();
var ops_cpu = /*#__PURE__*/function () {
  function ops_cpu() {
    _classCallCheck(this, ops_cpu);

    _defineProperty(this, "Tensor_type", Tensor);

    _defineProperty(this, "optimizer", {
      SGD: function SGD(parameters, lr) {
        return new _SGD(parameters, lr);
      }
    });
  }

  _createClass(ops_cpu, [{
    key: "tensor",
    value: function tensor(array, shape) {
      var is_sparse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      return new Tensor(array, shape, is_sparse);
    }
  }, {
    key: "find_tot",
    value: function find_tot(shape) {
      var tot = shape.reduce(function (a, b) {
        return a * b;
      });
      return tot;
    }
  }, {
    key: "randn",
    value: function randn$1(shape) {
      var is_sparse = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var tot = this.find_tot(shape);
      var res = [];

      for (var r = 0; r < tot; r++) {
        res.push(randn(0, 0.4));
      }

      return this.tensor(res, shape, is_sparse);
    }
  }, {
    key: "ones",
    value: function ones(shape) {
      var is_sparse = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var tot = this.find_tot(shape);
      return this.tensor(new Array(tot).fill(1), shape, is_sparse);
    }
  }, {
    key: "zeros",
    value: function zeros(shape) {
      var is_sparse = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (!is_sparse) {
        var tot = this.find_tot(shape);
        return this.tensor(new Array(tot).fill(0), shape, is_sparse);
      } else {
        return this.tensor([], shape, is_sparse);
      }
    }
  }, {
    key: "fill",
    value: function fill(shape, value) {
      var is_sparse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var tot = this.find_tot(shape);
      return this.tensor(new Array(tot).fill(value), shape, is_sparse);
    }
  }, {
    key: "add",
    value: function add(a, b) {
      var res = new Tensor(new Array(a.value.data.length).fill(0), a.value.shape, a.value.is_sparse);
      res.parents = [a, b];

      res.feed = function () {
        for (var v = 0; v < res.value.data.length; v++) {
          res.value.data[v] = 0;
        }
        ops.basic(a.value, b.value, res.value, ops.basic_types.add);
      };

      res.feed();

      res.back = function () {
        var grada = ops.unbroadcast(res.grad, a.value.shape);
        var gradb = ops.unbroadcast(res.grad, b.value.shape);
        ops.basic(grada, a.grad, a.grad, ops.basic_types.add);
        ops.basic(gradb, b.grad, b.grad, ops.basic_types.add);
      };

      return res;
    }
  }, {
    key: "sub",
    value: function sub(a, b) {
      var res = new Tensor(new Array(a.value.data.length).fill(0), a.value.shape, a.value.is_sparse);
      res.parents = [a, b];

      res.feed = function () {
        for (var v = 0; v < res.value.data.length; v++) {
          res.value.data[v] = 0;
        }
        ops.basic(a.value, b.value, res.value, ops.basic_types.sub);
      };

      res.feed();

      res.back = function () {
        var grada = ops.unbroadcast(res.grad, a.value.shape);
        var gradb = ops.unbroadcast(res.grad, b.value.shape);
        ops.basic(grada, a.grad, a.grad, ops.basic_types.add);
        ops.basic(gradb, b.grad, b.grad, ops.basic_types.add);
        b.grad.data.map(function (v) {
          return v * -1;
        });
      };

      return res;
    }
  }, {
    key: "mul",
    value: function mul(a, b) {
      var res = new Tensor(new Array(a.value.data.length).fill(0), a.value.shape, a.value.is_sparse);
      res.parents = [a, b];

      res.feed = function () {
        for (var v = 0; v < res.value.data.length; v++) {
          res.value.data[v] = 0;
        }
        ops.basic(a.value, b.value, res.value, ops.basic_types.mul);
      };

      res.feed();

      res.back = function () {
        var gradA = ops.unbroadcast(res.grad, a.value.shape);
        var gradB = ops.unbroadcast(res.grad, b.value.shape);
        var gradb = new nArray(new Array(a.grad.data.length).fill(0), a.grad.shape, a.grad.is_sparse);
        ops.basic(gradA, a.value, gradb, ops.basic_types.mul);
        ops.basic(gradb, b.grad, b.grad, ops.basic_types.add);
        var grada = new nArray(new Array(a.grad.data.length).fill(0), a.grad.shape, a.grad.is_sparse);
        ops.basic(gradB, b.value, grada, ops.basic_types.mul);
        ops.basic(grada, a.grad, a.grad, ops.basic_types.add);
      };

      return res;
    }
  }, {
    key: "div",
    value: function div(a, b) {
      var bi = this.recp(b);
      return this.mul(a, bi);
    }
  }, {
    key: "transpose",
    value: function transpose(a, dimension) {
      var dim = dimension ? dimension : a.value.shape.map(function (v, i) {
        return a.value.shape.length - 1 - i;
      });
      var res = new Tensor(new Array(a.value.data.length).fill(0), util.cal_step_change(a.value.shape, dim), a.value.is_sparse);
      res.parents = [a, null];

      res.feed = function () {
        for (var v = 0; v < res.value.data.length; v++) {
          res.value.data[v] = 0;
        }
        ops.transpose(a.value, res.value, dim);
      };

      res.feed();

      res.back = function () {
        var grad = new nArray(new Array(a.grad.data.length).fill(0), a.grad.shape, a.grad.is_sparse);
        ops.transpose(res.grad, grad, dim);
        ops.basic(grad, a.grad, a.grad, ops.basic_types.add);
      };

      return res;
    }
  }, {
    key: "matmul",
    value: function matmul(a, b) {
      var res_size = 1;
      var res_shape = [];

      for (var i = 0; i < a.value.shape.length - 1; i++) {
        res_size *= a.value.shape[i];
        res_shape[i] = a.value.shape[i];
      }

      res_size *= b.value.shape[b.value.shape.length - 1];
      res_shape[b.value.shape.length - 1] = b.value.shape[b.value.shape.length - 1];
      var res = new Tensor(new Array(res_size).fill(0), res_shape, a.value.is_sparse);
      res.parents = [a, b];

      res.feed = function () {
        for (var v = 0; v < res.value.data.length; v++) {
          res.value.data[v] = 0;
        }
        ops.matmul(a.value, b.value, res.value);
        res.grad.shape = Array.from(res.value.shape);
      };

      res.feed();

      res.back = function () {
        var at = new nArray(new Array(a.value.data.length).fill(0), a.value.shape, a.value.is_sparse);
        var bt = new nArray(new Array(b.value.data.length).fill(0), b.value.shape, b.value.is_sparse);
        var grada = new nArray(new Array(a.grad.data.length).fill(0), a.grad.shape, a.grad.is_sparse);
        var gradb = new nArray(new Array(b.grad.data.length).fill(0), b.grad.shape, b.grad.is_sparse);
        var dima = a.grad.shape.map(function (v, i) {
          return i;
        });
        var t = dima[dima.length - 1];
        dima[dima.length - 1] = dima[dima.length - 2];
        dima[dima.length - 2] = t;
        ops.transpose(a.value, at, dima);
        var dimb = b.grad.shape.map(function (v, i) {
          return i;
        });
        t = dimb[dimb.length - 1];
        dimb[dimb.length - 1] = dimb[dimb.length - 2];
        dimb[dimb.length - 2] = t;
        ops.transpose(b.value, bt, dimb);
        ops.matmul(res.grad, bt, grada);
        ops.matmul(at, res.grad, gradb);
        var gradA = ops.unbroadcast(grada, a.grad.shape);
        var gradB = ops.unbroadcast(gradb, b.grad.shape);
        ops.basic(gradA, a.grad, a.grad, ops.basic_types.add);
        ops.basic(gradB, b.grad, b.grad, ops.basic_types.add);
      };

      return res;
    }
  }, {
    key: "get_output",
    value: function get_output(s) {
      if (!s) return;

      for (var p = 0; p < s.parents.length; p++) {
        this.get_output(s.parents[p]);
      }

      s.feed();
      return s;
    }
  }, {
    key: "grad_zero",
    value: function grad_zero(s) {
      if (!s) return;
      s.grad.data = s.grad.data.map(function (v) {
        return 0;
      });

      for (var p = 0; p < s.parents.length; p++) {
        this.grad_zero(s.parents[p]);
      }
    }
  }, {
    key: "backpass_main",
    value: function backpass_main(s) {
      if (!s) return;
      s.back();

      for (var p = 0; p < s.parents.length; p++) {
        this.backpass_main(s.parents[p]);
      }
    }
  }, {
    key: "backpass",
    value: function backpass(s, res) {
      if (res) {
        s.grad.data = res.value.data;
      } else {
        s.grad.data = s.grad.data.map(function (v) {
          return 1;
        });
      }

      this.backpass_main(s);
    }
  }, {
    key: "sig",
    value: function sig(a) {
      return this.applyfn(a, function (z) {
        return 1.0 / (1.0 + Math.exp(-1 * z));
      }, function (z) {
        return 1.0 / (1.0 + Math.exp(-1 * z)) * (1 - 1.0 / (1.0 + Math.exp(-1 * z)));
      });
    }
  }, {
    key: "relu",
    value: function relu(a) {
      return this.applyfn(a, function (z) {
        if (0 > z) {
          return 0;
        } else if (0 < z) {
          return z;
        } else {
          return z;
        }
      }, function (z) {
        if (z > 0) {
          return 1;
        } else {
          return 0;
        }
      });
    }
  }, {
    key: "tanh",
    value: function tanh(a) {
      return this.applyfn(a, function (z) {
        return (Math.exp(z) - Math.exp(-z)) / (Math.exp(z) + Math.exp(-z));
      }, function (z) {
        return 1 - (Math.exp(z) - Math.exp(-z)) / (Math.exp(z) + Math.exp(-z)) * (Math.exp(z) - Math.exp(-z)) / (Math.exp(z) + Math.exp(-z));
      });
    }
  }, {
    key: "recp",
    value: function recp(a) {
      return this.applyfn(a, function (z) {
        return 1 / z;
      }, function (z) {
        return -1 / (z * z);
      });
    }
  }, {
    key: "applyfn",
    value: function applyfn(a, fn, delta) {
      var res = new Tensor(new Array(a.value.data.length).fill(0), a.value.shape, a.value.is_sparse);
      res.parents = [a, null];

      res.feed = function () {
        ops.applyfn(a.value, res.value, fn);
      };

      res.feed();

      res.back = function () {
        var grad = new nArray(new Array(a.grad.data.length).fill(0), a.grad.shape, a.grad.is_sparse);
        ops.applyfn(a.value, grad, delta);
        ops.basic(res.grad, grad, grad, ops.basic_types.mul);
        ops.basic(grad, a.grad, a.grad, ops.basic_types.add);
      };

      return res;
    }
  }]);

  return ops_cpu;
}();

var _SGD = /*#__PURE__*/function () {
  function _SGD(parameters, lr) {
    _classCallCheck(this, _SGD);

    this.parameters = parameters;
    this.lr = lr;
  }

  _createClass(_SGD, [{
    key: "step",
    value: function step() {
      var _this = this;

      this.parameters.forEach(function (t) {
        for (var i = 0; i < t.value.data.length; i++) {
          t.value.data[i] -= t.grad.data[i] * _this.lr;
        }
      });
    }
  }]);

  return _SGD;
}();

var ops_cpu$1 = ops_cpu;
function cpu() {
  return Promise.resolve(new ops_cpu());
}

var backs = /*#__PURE__*/Object.freeze({
  __proto__: null,
  ops_cpu: ops_cpu$1,
  cpu: cpu
});

function Linear(backend, in_features, out_features) {
  var bias = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

  function feed(input) {
    var m_res = backend.matmul(input, backend.transpose(feed.weights));
    if (bias) return backend.add(m_res, feed.biases);else return m_res;
  }

  feed.in_features = in_features;
  feed.out_features = out_features;
  feed.weights = backend.randn([feed.out_features, feed.in_features]);
  feed.biases = backend.randn([1, feed.out_features]);
  return feed;
}
function dropout(backend, in_features, out_features) {
  var bias = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;

  function feed(input) {
    var m_res = backend.matmul(input, backend.transpose(feed.weights));
    if (bias) return backend.add(m_res, feed.biases);else return m_res;
  }

  feed.in_features = in_features;
  feed.out_features = out_features;
  feed.weights = backend.randn([feed.out_features, feed.in_features]);
  feed.biases = backend.randn([1, feed.out_features]);
  return feed;
}

var layers = /*#__PURE__*/Object.freeze({
  __proto__: null,
  Linear: Linear,
  dropout: dropout
});

var deepnet = {
  platforms: backs,
  nn: layers
};

if (typeof window !== 'undefined') {
  window.deepnet = deepnet;
}

if (typeof module !== 'undefined') {
  module.exports = deepnet;
}

export { deepnet };
//# sourceMappingURL=deepnet-browser.mjs.map
